<?
/*
Copyright  (c)  2003, Vladimir V. Vasiltsov (aka eXOR exor@exor.com.ru) and
Vladimir S. Menshakov (aka megath megath@netive.ru) All rights reserved.

Redistribution  and  use  in  source  and  binary  forms,  with  or without
modification, are permitted provided that the following conditions are met:

    *  Redistributions  of  source  code  must  retain  the above copyright
    notice, this list of conditions and the following disclaimer.
    *  Redistributions  in  binary  form must reproduce the above copyright
    notice,  this  list  of  conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.
    * The name of the author may not be used to endorse or promote products
    derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND  ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE  DISCLAIMED.  IN  NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE  FOR  ANY  DIRECT,  INDIRECT,  INCIDENTAL,  SPECIAL,  EXEMPLARY,  OR
CONSEQUENTIAL  DAMAGES  (INCLUDING,  BUT  NOT  LIMITED  TO,  PROCUREMENT OF
SUBSTITUTE  GOODS  OR  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT,  STRICT  LIABILITY,  OR  TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.
*/
require_once("$bu_dir/bu_bench.php");
require_once("$bu_dir/bu_mangle.php");
require_once("$bu_dir/process.php");

class Cacher {

function backmerge_objects(&$o1, &$o2) {
    if (!is_object($o1) || !is_object($o2)) die("invalid object for backmerging.");
    foreach(array_keys(get_object_vars($o1)) as $k) {	
	if (is_object($o1->$k) && is_object($o2->$k)) $this->backmerge_objects($o1->$k, $o2->$k);
	else $o2->$k = $o1->$k;
    }
    
    foreach(array_keys(get_object_vars($o2)) as $k) {
	$o1->$k = $o2->$k;
	//unset($o2->$k);
    }
}


function bu_merge_objects(&$o1, &$o2) {
    if (!is_object($o1) || !is_object($o2)) return;
    
    foreach(array_keys(get_object_vars($o2)) as $k) {
	if (is_object($o2->$k)) {
	    $this->bu_merge_objects($o1->$k, $o2->$k);
	} else $o1->$k = $o2->$k;
    }
}

function bu_get_templates($template, &$_page) {
    global $bu_dir, $bu_cache_dir, $bu_templates_dir;
    global $bu_always_reparse, $bu_debug;
    global $_page2; //fixme: get rid of it!
    //=====	
    //globals from xhtml.php
    global $unclosed_tags, $greedy_tags;
    	
    $bu_savedir=getcwd();
    chdir($bu_templates_dir);
    
    $bu_tf=$template;
    $bu_ftemp_rel=bu_correct_name($template).".php";
    $bu_ftemp=$bu_cache_dir.'/'.$bu_ftemp_rel;
    $bu_fdef=$bu_cache_dir.'/'.bu_correct_name($template).".def.php";
    $bu_fdeps=$bu_cache_dir.'/'.bu_correct_name($template).".deps.php";
    $bu_page_cache=$bu_cache_dir.'/'.bu_correct_name($template).".page.bin";

    $reparse=false;
/*
	if (!file_exists($bu_fdeps) || !file_exists($bu_ftemp) || !file_exists($bu_fdef) ||
		(filemtime($bu_ftemp)<filemtime($bu_templates_dir."/".$bu_tf))) $reparse=true;
*/
    if (file_exists($bu_fdeps) &&
    	file_exists($bu_ftemp) &&
        file_exists($bu_fdef)) {
        //now check all dependencies :)
        require($bu_fdeps);
        foreach($bu_deps as $d) {
            //print_r($d);
            $mt_now=@filemtime($d[file]);
            $mt_was=$d[mtime];
            //maybe != below is too strict ? :)
            if ($mt_was != $mt_now) $reparse=true;
        }
    } else $reparse=true;
    
    if ($bu_always_reparse) $reparse = true;

    if ($reparse) {
        require_once("$bu_dir/bu_parse.php");
	    add_time_point();
	    $p = new Parser();
	    
	    $p->bu_parse($bu_tf, $bu_fdef, $bu_ftemp, $bu_fdeps);
	    print_time_point("bu_parse");
    }
    chdir($bu_savedir);

    $skip=true;
    if ($reparse || !file_exists($bu_page_cache)) {
        require($bu_fdef);
    	$_page->_template = $bu_ftemp_rel;
		$_page->_name = $template;
		$_page->_created = time(); //mainly for level2 cache invalidation ;)
	
        $f = fopen($bu_page_cache, "w");	
		if (!$f) die("bu_cache: cannot write \$_page cache[$bu_page_cache]<br>\n");
		add_time_point();
		fwrite($f, serialize($_page));
		print_time_point("serialization to file");
        fclose($f);
        $skip=false;
	}

    if ($skip) {
        add_time_point();
        $f=fopen($bu_page_cache, "r");
        $_page = unserialize(fread($f, filesize($bu_page_cache)));
        fclose($f);
        print_time_point("deserialization from file");
	}
	
    add_time_point();
    $this->bu_merge_objects($_page, $_page2);
    print_time_point("bu_merge_objects");

    return array("definition"=>$bu_fdef, "template"=>$bu_ftemp);
}
}

function bu_use_template($t) {
    global $_page; 
    $first_time = !isset($_page->_template);
    $c = new Cacher();
    $r =  $c->bu_get_templates($t, $_page);
    if ($first_time) register_shutdown_function("bu_process_template");
    return $r;
}


//for backward compatability

function bu_get_templates($t) {
    return bu_use_template($t);
}


require_once("$bu_dir/tag.php");
require_once("$bu_dir/attribute.php");
require_once("$bu_dir/grid.php");
require_once("$bu_dir/page.php");

?>