<?

function bu_cleanup() {
    global $bu_cache_dir;
    @unlink($bu_cache_dir."/l2/.lock");
}

function bu_cache_cleanup($bu_force_cleanup = 0) {
    global $bu_cache_dir, $bu_cleanup_interval;
    global $_page;
    $_page = 0; //hehehe
    if (!$bu_force_cleanup && $bu_cleanup_interval == -1) return;
    $l2 = "$bu_cache_dir/l2";
    $cflag = "$l2/.latest";
    $clock = "$l2/.lock";
    
    if (file_exists($clock)) return;
    if (!file_exists($cflag)) {
	if (!@touch($cflag)) return;
	};
    
    $t = intval($bu_cleanup_interval);
    if ($t<=0) $t = 24*60*60;
    if ($bu_force_cleanup || filemtime($cflag)+$t > time()) return;
//    echo "cleaning up: $t<br>";
    add_time_point();
    touch($cflag);
    touch($clock);
    
    ignore_user_abort(1);
    set_time_limit(0);
    
    register_shutdown_function("bu_cleanup");
    
    $dh = opendir($l2);
    while($r = readdir($dh)) {
	if ($r{0} == '.') continue;
	$fname = $l2."/".$r;
	if (filemtime($fname) + $t < time()) unlink($fname);
    }
    closedir($dh);
    
    unlink($clock);
    print_time_point("cache cleanup");
}

class BublaCacheL2 {

function prepare(&$_page) {
	global $bu_l2_cache;
	global $bu_cache_dir;
	
	$this->do_cache = false;
	
	$tn = $_page->_name;
	//echo "[$tn]";
	if (!is_array($_page->_vars[$tn])) return;
	if (is_array($bu_l2_cache)) {
    	if (!in_array($_page->_name, $bu_l2_cache)) return;
	} elseif (!$bu_l2_cache) return;
	
	$this->vars = $_page->_vars[$tn];
	$this->name = $_page->_name;
	
	if (!is_dir($bu_cache_dir."/l2")) mkdir($bu_cache_dir."/l2", 0777);
	
	$this->do_cache = true;
}

function query(&$_page) {
	global $bu_cache_dir;
	if (!$this->do_cache) return false;
	
	add_time_point();
	
	$ugly_hash='';
	foreach($this->vars as $n) {
		$ugly_hash .= md5(serialize($_page->$n));
	}
	$pid = md5($ugly_hash);
	
	//$pid = md5(serialize($_page)."-${bu_debug}-");
	//echo "[$pid]";
	print_time_point("hashing page content");
	$this->fcontent = $fcontent = "$bu_cache_dir/l2/".$this->name.".$pid.html";
	//echo "$fcontent<br>\n";
	if (file_exists($fcontent)) {
	    	//fixme : add LastModified, COntent size and other stuff. 
	    	//if document in cache, it can be considered static ;)
	    
	    	touch($fcontent);
	    	readfile($fcontent);
	    	print_time_point("reading template [hit]");
	    	bu_cache_cleanup();
	    	return true;
		}
	ob_start();
	return false;
}

function capture() {
	if (! $this->do_cache) return;
	$doc = ob_get_contents();
	ob_end_flush();
	$f = @fopen($this->fcontent, "w");
	if ($f) {
	    fwrite($f, $doc);
	   	fclose($f);
	}
	bu_cache_cleanup();
}

}
?>