<?
/*
Copyright  (c)  2003, Vladimir V. Vasiltsov (aka eXOR exor@exor.com.ru) and
Vladimir S. Menshakov (aka megath megath@netive.ru) All rights reserved.

Redistribution  and  use  in  source  and  binary  forms,  with  or without
modification, are permitted provided that the following conditions are met:

    *  Redistributions  of  source  code  must  retain  the above copyright
    notice, this list of conditions and the following disclaimer.
    *  Redistributions  in  binary  form must reproduce the above copyright
    notice,  this  list  of  conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.
    * The name of the author may not be used to endorse or promote products
    derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND  ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE  DISCLAIMED.  IN  NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE  FOR  ANY  DIRECT,  INDIRECT,  INCIDENTAL,  SPECIAL,  EXEMPLARY,  OR
CONSEQUENTIAL  DAMAGES  (INCLUDING,  BUT  NOT  LIMITED  TO,  PROCUREMENT OF
SUBSTITUTE  GOODS  OR  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT,  STRICT  LIABILITY,  OR  TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.
*/

require_once("$bu_dir/xhtml.php");
require_once("$bu_dir/bu_mangle.php");

class Parser {
function Parser() {
    $this->bu_tag_class = array(
	"subtemplate" => "Subtemplate"
    );
    $this->bu_off=false;
    $this->bu_off_old=0;
 
    $this->bu_depth=0;
    $this->bu_glob=0;
    $this->bu_glob_name=false;

    $this->bu_fin='';
    $this->bu_def='';	
	$this->bu_doc='';

	$this->bu_tags=array();
	$this->bu_history=array();
	$this->bu_page=array();
	$this->bu_deps=array();
	
	$this->bu_used_vars = array ();
	$this->bu_disable_l2 = false;
}

function replace_static_cb($r) {
	//echo "[$r]<br>\n";
	$this->bu_used_vars[ $r ] = true;
	return str_replace("\\1", $r, $this->embed_code);	
}

function replace_static(&$doc, $mask = false) {
    global $bu_embedded_vars;
    if (!$bu_embedded_vars) return;
    $this->embed_code = ($mask)?"<'.'?=\$_page->getVar(\\'\\1\\');?'.'>":"<?=\$_page->getVar('\\1');?>";
    $doc = preg_replace("/\\\$\\{(.+?)\\}/ie", "\$this->replace_static_cb('\\1');" , $doc);
}

function bu_hash($name, $off) {
    return sprintf("%x", crc32($this->bu_fin."/$name"."_".$off));
	//return $name."_".$off;
}

function bu_is_global() {
    foreach($this->bu_tags as $t) if (strlen($t[name])) return false;
    return true;
}

function bu_last_named() {
    for($i=sizeof($this->bu_tags); $i>=0; $i--) 
        if (strlen($this->bu_tags[$i][name])) return $i;
    return false;
}

function bu_el_start($parser, $tag, $attrs) {
    $this->bu_depth++;
//    echo "$tag: $bu_depth\n";
    $this->bu_off=xml_get_current_byte_index($parser);
    $a=array();
    $tag=strtolower($tag);
    foreach($attrs as $k=>$v) {
        $k = strtolower($k);
//        if ($k == "name") $v = preg_replace("/[\\[\\]]/", "", $v);
		$a[$k]=$v;
    }
    $attrs=$a;
    unset($a);
    
    $akeys=array_keys($attrs);
    $pg_flag=$this->bu_is_global();
//    if (!$bu_glob && in_array("name", $akeys)) $bu_glob=sizeof($bu_tags);
    $correct_name=bu_correct_name($attrs[id]);
	if (strlen($correct_name)) $this->bu_used_vars[$correct_name] = true;
    array_push($this->bu_tags,  
	array(
	    "tag"=>$tag, 
	    "name"=>$correct_name, 
	    "attrs"=>$attrs, 
	    "elements"=>array(),
		"cname"=>"BUC_".$this->bu_hash($correct_name, $this->bu_off))
		);

    $g_flag=$this->bu_is_global();

//    echo $tag." ".(($g_flag)?"t":"f")."<-".(($pg_flag)?"t":"f")."\n";
//    print_r($bu_tags);	    
    $t="<$tag";
    $a='';
    foreach($attrs as $k=>$v) $a.=" $k=\"$v\"";
    $t.="$a>";

    if ($g_flag) {
	$this->bu_doc.=$t;
	return;
    } elseif ($pg_flag) {
	$this->bu_doc.="<? \$_page->${correct_name}->process(); ?>";
	return;
    }
//    print_r($t);
//    echo "\n";
    if (!strlen($correct_name)) $this->bu_tags[$this->bu_last_named()][cdata].="$t";
    
}

function bu_mkattrs($a) {
    if (!is_array($a)) echo "mkattrs: BUG, not array passed\n";
    $attrs='';
    foreach($a as $k=>$v) $attrs.="'$k'=>'".str_replace("'", "\\'", $v)."',";
    $attrs=substr($attrs, 0, -1);
    return $attrs;
}

function bu_el_end($parser, $tag) {
    global $unclosed_tags;
    $tag=strtolower($tag);

    $unclosed=intval(in_array($tag, $unclosed_tags));

    if (!$unclosed) {
//        echo "closed: $tag<br>";
		if ($this->bu_is_global()) $this->bu_doc.="</$tag>";
//		else $this->$bu_tags[bu_last_named()][cdata].="</$tag>";
    }
    
    $t=array_pop($this->bu_tags);
    
    $g_flag=$this->bu_is_global();
    /*
    here comes major problem. (reported by ernst)
    bubla cannot process nested named tags in datasource.
    <table name="table_1">
    <tr><td name="row"><a name="link" href="y">xxx</a></td></tr>
    </table>

    temporary fix is to recusively collect all _elements tags in parse time,
	but imho it's incorrect

    r_hack and some fix me about recursive elements are all about it
	*/

    $r_hack = 0;
    if (!$g_flag && strlen($t[name])) {
	for($i=sizeof($this->bu_tags); $i>=0; $i--) {
	    if (strlen($this->bu_tags[$i][name])) {
//		echo "$i: ".$this->bu_tags[$i][name]." $t[name]<br>";
		array_push($this->bu_tags[$i][elements], array(tag=>$t[tag], name=>$t[name], cname=>$t[cname], attrs=>$t[attrs], elements=>$t[elements], r_hack=>$r_hack));
		//i push newly created array to do not copy unnessesary and often BIG $t[cdata];
		if (!$r_hack) $this->bu_tags[$i][cdata].="<? \$_page->".$t[name]."->process(); ?>";
		//fixme: uncomment block below to reverse bubla behaviour to non-recursive _elements array !
        $r_hack =1;
		//break;
	    }
	}
	//print_r($this->bu_tags[$i]);
    }
//    echo $t[name]."\n";

//what means code below !?!!!!
    if (!$g_flag && !strlen($t[name]) && !in_array($tag, $unclosed_tags)) $this->bu_tags[$this->bu_last_named()][cdata].="</$tag>";

    $attrs=$this->bu_mkattrs($t[attrs]);
    $kids=array();
    $kids_start='';
    $globals="\$_page";
    foreach($t[elements] as $e) {
//	$t=$bu_tags[$e];
	$ea=$this->bu_mkattrs($e[attrs]);
	array_push($kids, "&\$_page->$e[name]");
//	$globals.="\$$e, ";
//	echo $e[name];
	//$kids_start.="\$_page->$e[name]=new Grid(\"$e[tag]\", array($ea), array(), $unclosed);\n";
	$kids_start.="\$_page->$t[name]->$e[name]=&\$_page->$e[name];\n";
	//$kids_start.=bu_register($e[name]);
    }
//    $kids_start.="Grid::Grid(\$t, \$a, array(".join(',', $kids)."), \$u);";
//    $globals=substr($globals, 0, -2);
    
    if (strlen($globals)) $globals="global $globals;\n";
//old code: 
    //if (!in_array($t[name], $bu_history) && strlen($t[name])) {
    if (strlen($t[name])) {
    /*
	$bu_def.=
"
class $t[cname] extends Grid {
    function $t[cname](\$t, \$a, \$e, \$u) { global \$_page; $kids_start }
    function show() { 
    $globals
	?>$t[cdata]<?}
}
";
*/
    $kids_array = "array(".join(',', $kids).")";
//	if (bu_is_global())
	$classname = "Grid";
	if (array_key_exists($t[tag], $this->bu_tag_class)) {
	    $classname = $this->bu_tag_class[$t[tag]];
	}
	$this->bu_def.="\$_page->$t[name]=new ${classname}(\"$t[tag]\", array($attrs), $kids_array, $unclosed);\n";
	$cdata = str_replace("'", "\\'", $t[cdata]);
	$this->replace_static($cdata, true);
	$this->bu_def.="\$_page->$t[name]->_cdata = '".$cdata."';\n";
//	$this->$bu_def.=$kids_start;
	//array_push($this->bu_history, $t[name]);
    }
}

function bu_cdata($parser, $cdata) {
    $ltag=sizeof($this->bu_tags)-1;
    if ($this->bu_is_global()) $this->bu_doc.=$cdata;
	else $this->bu_tags[$this->bu_last_named()][cdata].=$cdata;
}

function bu_stuff($parser, $stuff) {
}

function bu_include_cb($a) {
	//echo $a;
	if (preg_match("/id\\s*=\\s*\\\"(.+)\\\"/i", $a, $m)) {
	    $t = preg_replace("|(?<!/)>|x", " />", $a);
		//echo "[$m[1]]<br>\n";
		$this->bu_disable_l2 = true;
		return preg_replace("/include/", "subtemplate", $t);
	} else if (preg_match("/file\\s*=\\s*\\\"(.+)\\\"/i", $a, $m)) {
		$success=false;
		//print_r($m);
		$fn=$this->bu_fin_dir."/".$m[1];
		$f=@fopen($fn, "r");
		if ($f) {
			$d=fread($f, filesize($fn));
			fclose($f);
			$success=true;
		}
		if (!$success) die("Cannot open include file : $fn");
		array_push($this->bu_deps, array("file"=>$fn, "mtime"=>filemtime($fn)));
		return $d;
	}
	return '<!-- Unimplemented include -->';
}

function bu_process_includes($html) {
	//hack me! 
    return preg_replace("/(<include (.*?))>/sie", "\$this->bu_include_cb(\"\\0\")", $html);
    //return $html;
}

function bu_unparsed($parser, $ent) {
    echo "found: $ent<br>";
}

function bu_parse($fin, $fdef, $fout, $fdeps) {
    global $bu_drain_xml;
	
    $this->bu_fin=$fin;
    $this->bu_fin_dir=dirname($fin);
    $this->bu_doc='';
    $this->bu_def="<?\n\$_page = new Page();\n";
	
    if (!($f=@fopen($fin, "r"))) die("bu_parse: cannot open input file[$fin]\n");
    $xml=xml_parser_create();
    xml_parser_set_option($xml, XML_OPTION_CASE_FOLDING, 1);
    xml_set_object($xml, $this);
    
    xml_set_element_handler($xml, "bu_el_start", "bu_el_end");
    xml_set_character_data_handler($xml, "bu_cdata");
//    xml_set_external_entity_ref_handler($xml, "bu_unparsed");
//    xml_set_unparsed_entity_decl_handler($xml, "bu_unparsed");
    xml_set_default_handler($xml, "bu_stuff");
    $data=fread($f, filesize($fin));
	
	//FIXME!!! Rewrite this code to be recursive! -(
	//$bu_templates_path=dirname($fin);
	do {
		$data2=$this->bu_process_includes($data);
		if ($data==$data2) break;
		$data=$data2;
	} while(1);
	
	
    $data=html2xhtml($data);
		
	if ($bu_drain_xml) {
		$n=2;
		$xdata="1 ".preg_replace("/\\n/es", "sprintf(\"\\n\".(\\\$n++).\"\")", $data);
		//$xdata=$data;
		echo "<pre>\n".htmlspecialchars($xdata)."\n</pre>";
	}

    if (!xml_parse($xml, $data, true)) {
	$line = xml_get_current_line_number($xml);
	$col = xml_get_current_column_number($xml);
	$u = 2; //up $u lines
	$t = 2*$u+1; //show total $t 
	$p = ($line>$u)?($line-$u):0;
	$x = array_splice(explode("\n", $data), $p, $t);
	echo "<pre>\n";
	for($i = 0; $i<sizeof($x); ++$i) {
	    echo ($i+$p+1).':'.htmlspecialchars($x[$i])."\n";
	}
	echo "</pre>\n";
	die("XML error at line $line:$col ".
	    xml_error_string(xml_get_error_code($xml))."\n");
    }

    $this->bu_def.='?>';
    fclose($f);
    xml_parser_free($xml);
    
    $this->replace_static($this->bu_doc);
    
    $f=@fopen($fout, "w");
    if ($f===FALSE) die("<b>Bubla</b>: Cannot write template file to cache");
//    echo "xxxx".htmlspecialchars($xhtml_doctype);
	fwrite($f, $xhtml_doctype);
    //fwrite($f, $this->bu_doc);
    fwrite($f, substr($this->bu_doc, 5, -6)); //strip global txt, added by xhtml
    fclose($f);

    $f=@fopen($fdef, "w");
    if ($f===FALSE) die("<b>Bubla</b>: Cannot write definition file to cache");
    fwrite($f, $this->bu_def);
	if (!$this->bu_disable_l2) {
		fwrite($f, "\n<"."?\n\$_page->_vars['$fin']=array(");
		$s = '';
		foreach($this->bu_used_vars as $v=>$_t) {
			fwrite($f, "$s'$v'");
			$s=",";
		}
		fwrite($f, ");\n?".">");
	}
    fclose($f);

    array_push($this->bu_deps, array('file'=>$fin, 'mtime'=>filemtime($fin)));

    $f=@fopen($fdeps, "w");
    if ($f===FALSE) die("<b>Bubla</b>: Cannot write dependencies file to cache");
    fwrite($f, "<?\n\$bu_deps=array(\n");
    $d='';
    foreach($this->bu_deps as $a) {
        $d.="array( ";
        foreach($a as $k=>$v) {
            $d.="'$k' => '$v', ";
        }
        $d=substr($d, 0, -2);
        $d.="),\n";
    }
    $d=substr($d, 0, -2);
    fwrite($f, "$d\n);\n");
	fwrite($f, "\n?".">");
    fclose($f);

}
}
?>