<?
/*
Copyright  (c)  2003, Vladimir V. Vasiltsov (aka eXOR exor@exor.com.ru) and
Vladimir S. Menshakov (aka megath megath@netive.ru) All rights reserved.

Redistribution  and  use  in  source  and  binary  forms,  with  or without
modification, are permitted provided that the following conditions are met:

    *  Redistributions  of  source  code  must  retain  the above copyright
    notice, this list of conditions and the following disclaimer.
    *  Redistributions  in  binary  form must reproduce the above copyright
    notice,  this  list  of  conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.
    * The name of the author may not be used to endorse or promote products
    derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND  ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE  DISCLAIMED.  IN  NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE  FOR  ANY  DIRECT,  INDIRECT,  INCIDENTAL,  SPECIAL,  EXEMPLARY,  OR
CONSEQUENTIAL  DAMAGES  (INCLUDING,  BUT  NOT  LIMITED  TO,  PROCUREMENT OF
SUBSTITUTE  GOODS  OR  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT,  STRICT  LIABILITY,  OR  TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.
*/
$unclosed_tags=array(
	"img", "br", "meta", "base", "basefont", "col", "frame", 
	"hr", "input", "isindex", "link", "param", "area", "li");

$greedy_tags = array(
    "p"
);


function xhtml_decl($a) {
    //print_r($a);
    //FIXME ! 
    return "<!".$a[1]." \"\">";
}

function GetCDATAValue($value)
{
        if (!IsSet($value) || $value == '')
                return '';
        return '<![CDATA['.$value.']]>';
}


function repl_comment($comment, $restore = 0)
{
        $comment = str_replace('\"', '"', $comment);
        if ($restore)
        {       $comment = str_replace('&lt;', '<', $comment);
                $comment = str_replace('&gt;', '>', $comment);

                $comment = str_replace('&amp;', '&', $comment);
                return $comment;
        } else
        {
                $comment = str_replace('<', '&lt;', $comment);
                $comment = str_replace('>', '&gt;', $comment);

                $comment = str_replace('&lt;!--', '<!--', $comment);
                $comment = str_replace('--&gt;', '-->', $comment);
                return GetCDATAValue($comment);
        }
}

function doctype_replace_cb($m) {
    $x = substr_count($m[0], '"');
    
    if ($x == 2) {
	//fixme: write proper w/o !
	$p = strrpos($m[0], '>');
	if ($p !== false) {
	    return substr_replace($m[0], ' ""', $p, 0);
	}
    }

    return $m[0];
}

function repl_tag($full_tag)
{
        global $minimized_attrs_arr;
        $full_tag = str_replace('\"', '"', $full_tag);
        
		switch (substr($full_tag, 0, 1))
        {
        case '/':
                // closing tag
                return '<'.strtoupper($full_tag).'>';
        case '!':
                // comment
                return '<'.$full_tag.'>';
        }
        $data = preg_split('/\s+/', $full_tag, 2);

        $tag_name = strtoupper(array_shift($data));
        $ret = '<'.$tag_name;
        if (count($data))
        {
                $attrs = array_shift($data);
                if (substr($attrs, -1) == '/')
                        $attrs = substr($attrs, 0, -1);

                // WARNING!!! This code could affect text in quotes in attributes
//              $min_attrs = '('.join(')|(', $minimized_attrs_arr).')';
//              $attrs = preg_replace("/\s($min_attrs)\s/i", ' \1="1" ', ' '.$attrs.' ');
                // --------------------------------------------------------------

                $ret .= ' '.$attrs;
        }
        //$ret .= (is_empty_tag($tag_name) ? ' />' : '>');
        return $ret.">";
}

function PreConvert(&$tmpl_body, $type = 1)
{
    $tmpl_body = str_replace('&', '&amp;', $tmpl_body);
    $tmpl_body = preg_replace_callback("/(\<!DOCTYPE.+?>)/si", "doctype_replace_cb", $tmpl_body);
    
//print '<pre>'.HTMLSpecialChars($tmpl_body).'</pre>';
        $tmpl_body = preg_replace("/(\<!--.+?-->)/se", "repl_comment('\\1')", $tmpl_body);
//        $tmpl_body = preg_replace('/<([\w\/][^>]*?)>/e', "repl_tag('\\1')", $tmpl_body);
        $tmpl_body = preg_replace("/(\<!--.+?-->)/se", "repl_comment('\\1', 1)", $tmpl_body);
}

function close_greedy($tag, $body, $close) {
    $tag = strtoupper($tag);
    $c1 = "/$tag";
    if (!strncasecmp($close, $c1, strlen($c1))) {
    	return "$body<$close>";
	}
//    echo htmlspecialchars("[$c1] [$close]")."<br>";
    return "$body</$tag><$close>";
}

function doctype_cb($m) {
    global $xhtml_doctype;
    $xhtml_doctype = $m[0]."\n";
    return '';
}

function html2xhtml($html) {
    global $unclosed_tags, $greedy_tags;
	//$html=str_replace('&', '&amp;', $html);
    $html=preg_replace_callback("/<!doctype(.*?)>/is", doctype_cb, $html);
//    echo $html;
    $t=$f=array();
    //$html=preg_replace($f, $t, $html);
    //echo htmlspecialchars($html);
    //return $html;
	
	PreConvert($html);

	foreach($unclosed_tags as $name) {
		array_push($f, "/(<$name.*?)\\/?>/si");
		array_push($t, "\\1 />");
    }
	$html=preg_replace($f, $t, $html);
   	foreach($greedy_tags as $t)
		for($i=0; $i<2; $i++) //repeat twice ;) DO NOT REMOVE. YOU WILL BE KILLED.
		{
			$re = "/(<$t( .*?)?".">.*?)<(.*?)>/ise";
//      	echo $t."=~".htmlspecialchars($re)."<br>";
//      	$html = preg_replace("/<$t( .*?)?".">.*?<\\/$t>/i", "[\\0]", $html);
			$html = preg_replace($re, "close_greedy(\"$t\", \"\\1\", \"\\3\")", $html);
		}

	return "<txt>$html</txt>";
}

?>